/********************************************************************
*--------------------------------------------------------------------
*    Titolo        :  C Enhanced - es8C
*                     Un LED collegato tra R5 e Vss lampeggia una
*                     volta al secondo con Timer0.
*    Data          :  01-05-2011
*    Modificato il :
*    Versione      :  V0.0
*    Ref. Hardware :  12F1571/2
*    Autore        :  afg
*
*--------------------------------------------------------------------
*********************************************************************
*  Impiego pin :
*  ----------------
*       12F1571/2 @ 8 pin
*
*                  |\/|
*             Vdd -|1    8|- Vss
*             RA5 -|2    7|- RA0
*             RA4 -|3    6|- RA1
*        RA3/MCLR -|4    5|- RA2
*                  |______|
*
*    Vdd               1: ++
*    RA5/OSC1/CLKIN    2: Out LED
*    RA4/OSC2/CLKOUT   3: In  
*    RA3/!MCLR/VPP     4: MCLR
*    RA2               5: In  
*    RA1/ICSPCLK       6: In  
*    RA0/ICSPDAT       7: In  
*    Vss               8: --
*
*
* RA5/T1CKI/PWM1/CW1G1A/[%RX-DT]/IOC
* RA4/AN3/C1IN-/[T1G]/[PWM2]/[CW1G1B]/[*TX-CK]/IOC
* RA3/[T1G]/IOC/MCLR
* RA2/AN2/C1OUT/T0CKI/PWM3/CWG1A-!CW!G!FLT]/INT/IOC
* RA1/AN1/Vref+/C1IN0-/PWM1/%RX-DT/IOC/ICSPCLK
* RA0/AN0/DAC1OUT/C1IN+/PWM2/CWG1B/%TX-CK/IOC/ICSPDAT
*
* [] rilocabili con APFCON
*  % solo 12F1572
*
* Note: - INTOSC default @ 500kHz*
********************************************************************/

// intosc, no clockout, no wdt, no pwrt, mclr, bor, no code prot.
// no WRT, no pll, no stack error, bor low, no bor lp, no LVP
#include "C:/Corso_C/MyIncludes/conf1572_0.h"

#include <xc.h>
#define Led LATAbits.LATA5

/************************* MAIN PROGRAM ****************************/
void main(){

    // Inizializza I/O
    ANSELA=0;               // no analogiche
    LATAbits.LATA5  = 1;    // preset LED on high
    TRISAbits.TRISA5 = 0;   // RA5 come output

  // abilitiamo wpu per protezione pin non usati
   OPTION_REGbits,nWPUEN = 0; 

  // Timer0 Registers: Prescaler=1:256; TMR0 Preset=12; Period=499,712 ms
   OPTION_REGbits.TMR0CS = 0;   // Clock Source = Internal Clock (CLKO)
   OPTION_REGbits.PSA  = 0;     // bit 3 Prescaler to Timer0
   OPTION_REGbits.PS  = 0b111;  // PS2:PS0: Prescaler 1:256
   TMR0 = 10;                   // preset for counter
   TMR0IF=0 ;                   // clear flag

// Loop principale 
   while (1) {    
     while (TMR0IF==0);     // attesa overflow
     TMR0 = 10;
     TMR0IF = 0 ;                      
     Led = ! Led;           // toggle LED
   }
}